-- Author       : Jan Kenneth Bekkeng
-- Company      : University of Oslo
-- File name    : SR_SerIn_redge.vhd 
-- Date         : 05.10.2010
-- Project      : FYS4220/9220 Lab3
-- Function     : Serial in parallel out shift register, rising edge. 




library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity SR_SerIn_redge is
  generic (
    width : integer := 16); 
    
  
  port
    (
    clk      : in  std_logic;
    DataIn   : in  std_logic;           
    shift_en : in  std_logic;
    DataOut  : out std_logic_vector(width-1 downto 0)
    );

end SR_SerIn_redge;


architecture SR_SerIn_arch of SR_SerIn_redge is

  signal data_int : std_logic_vector(width-1 downto 0);


begin

  SHIFT_REG:
  process (clk)
  begin
    
   if rising_edge(clk) then
      if (shift_en = '1') then
        data_int(0) <= DataIn;
        for i in width-2 downto 0 loop
          data_int(i+1) <= data_int(i);
        end loop;
      end if;
          
    end if;
  end process SHIFT_REG;

  DataOut <= data_int;

 
end SR_SerIn_arch;


  

    

